#!/bin/bash

move_left() {
    printf "l"
    irsend SEND_ONCE "playmobil" MOVE_LEFT
}
move_right() {
    printf "r"
    irsend SEND_ONCE "playmobil" MOVE_RIGHT
}
move_out() {
    printf "f"
    irsend SEND_ONCE "playmobil" MOVE_FAR
    clean_stdin;
}
move_in() {
    printf "n"
    irsend SEND_ONCE "playmobil" MOVE_NEAR
}
move_up() {
    printf "u"
    irsend SEND_ONCE "playmobil" MOVE_UP
}
move_down() {
    printf "d"
    irsend SEND_ONCE "playmobil" MOVE_DOWN
}
move_stop() {
    printf "."
    irsend SEND_ONCE "playmobil" KEY_STOP
}

clean_stdin()
{
    while read -rsn1 -t 0; do : ; done
}

printf "Keyboard controller for the Playmobil(r) large crane IR remote control via LIRC\n"
printf "Use the following keys (they fit the original remote layout, when used on the numeric keypad)\n"
printf "7/8 to turn left/right\n"
printf "4/5 to move out/in\n"
printf "1/2 to move up/down\n"
printf "9/6/3 to stop moving\n"
printf "CTRL_C to exit\n"

# read the key-strokes
while true
do
    # skip existing key-strokes, then take the next one
    clean_stdin;
    read -rsn1 key;
    case $key in
        7) move_left ;;
        8) move_right ;;
        4) move_out ;;
        5) move_in ;;
        1) move_up ;;
        2) move_down ;;
        9) move_stop ;;
        6) move_stop ;;
        3) move_stop ;;
        .) move_stop ;;
    esac
done
